searchData={"items":[{"type":"module","title":"Membrane.RawAudio","doc":"This module contains a definition and related functions for struct `t:Membrane.RawAudio.t/0`,\ndescribing a format of raw audio stream with interleaved channels.","ref":"Membrane.RawAudio.html"},{"type":"function","title":"Membrane.RawAudio.big_endian?/1","doc":"Determines if the sample values are represented by a number in big endian byte ordering.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#big_endian?/1"},{"type":"function","title":"Membrane.RawAudio.bytes_to_frames/3","doc":"Converts bytes to frames in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#bytes_to_frames/3"},{"type":"function","title":"Membrane.RawAudio.bytes_to_time/3","doc":"Converts bytes to time in Membrane.Time units in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#bytes_to_time/3"},{"type":"function","title":"Membrane.RawAudio.frame_size/1","doc":"Returns how many bytes are needed to store a single frame.\n\nInlined by the compiler","ref":"Membrane.RawAudio.html#frame_size/1"},{"type":"function","title":"Membrane.RawAudio.frames_to_bytes/2","doc":"Converts frames to bytes in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#frames_to_bytes/2"},{"type":"function","title":"Membrane.RawAudio.frames_to_time/3","doc":"Converts frames to time in Membrane.Time units in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#frames_to_time/3"},{"type":"function","title":"Membrane.RawAudio.little_endian?/1","doc":"Determines if the sample values are represented by a number in little endian byte ordering.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#little_endian?/1"},{"type":"function","title":"Membrane.RawAudio.sample_max/1","doc":"Returns maximum sample value for given sample format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#sample_max/1"},{"type":"function","title":"Membrane.RawAudio.sample_min/1","doc":"Returns minimum sample value for given sample format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#sample_min/1"},{"type":"function","title":"Membrane.RawAudio.sample_size/1","doc":"Returns how many bytes are needed to store a single sample.\n\nInlined by the compiler","ref":"Membrane.RawAudio.html#sample_size/1"},{"type":"function","title":"Membrane.RawAudio.sample_to_value/2","doc":"Converts one raw sample into its numeric value, interpreting it for given sample format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#sample_to_value/2"},{"type":"function","title":"Membrane.RawAudio.sample_type_fixed?/1","doc":"Determines if the sample values are represented by an integer.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#sample_type_fixed?/1"},{"type":"function","title":"Membrane.RawAudio.sample_type_float?/1","doc":"Determines if the sample values are represented by a floating point number.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#sample_type_float?/1"},{"type":"function","title":"Membrane.RawAudio.signed?/1","doc":"Determines if the sample values are represented by a signed number.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#signed?/1"},{"type":"function","title":"Membrane.RawAudio.silence/1","doc":"Returns one 'silent' sample, that is value of zero in given format' sample format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#silence/1"},{"type":"function","title":"Membrane.RawAudio.silence/3","doc":"Returns a binary which corresponds to the silence during the given interval\nof time in given format' sample format","ref":"Membrane.RawAudio.html#silence/3"},{"type":"function","title":"Examples: - Membrane.RawAudio.silence/3","doc":"The following code generates the silence for the given format\n\n    iex> alias Membrane.RawAudio\n    iex> format = %RawAudio{sample_rate: 48_000, sample_format: :s16le, channels: 2}\n    iex> silence = RawAudio.silence(format, 100 |> Membrane.Time.microseconds())\n     >","ref":"Membrane.RawAudio.html#silence/3-examples"},{"type":"function","title":"Membrane.RawAudio.time_to_bytes/3","doc":"Converts time in Membrane.Time units to bytes in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#time_to_bytes/3"},{"type":"function","title":"Membrane.RawAudio.time_to_frames/3","doc":"Converts time in Membrane.Time units to frames in given format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#time_to_frames/3"},{"type":"function","title":"Membrane.RawAudio.unsigned?/1","doc":"Determines if the sample values are represented by an unsigned number.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#unsigned?/1"},{"type":"function","title":"Membrane.RawAudio.value_to_sample/2","doc":"Converts value into one raw sample, encoding it with the given sample format.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#value_to_sample/2"},{"type":"function","title":"Membrane.RawAudio.value_to_sample_check_overflow/2","doc":"Same as value_to_sample/2, but also checks for overflow.\nReturns {:error, :overflow} if overflow happens.\n\nInlined by the compiler.","ref":"Membrane.RawAudio.html#value_to_sample_check_overflow/2"},{"type":"type","title":"Membrane.RawAudio.channels_t/0","doc":"","ref":"Membrane.RawAudio.html#t:channels_t/0"},{"type":"type","title":"Membrane.RawAudio.sample_rate_t/0","doc":"","ref":"Membrane.RawAudio.html#t:sample_rate_t/0"},{"type":"type","title":"Membrane.RawAudio.t/0","doc":"","ref":"Membrane.RawAudio.html#t:t/0"},{"type":"module","title":"Membrane.RawAudio.SampleFormat","doc":"This module defines sample formats used in `Membrane.RawAudio`\nand some helpers to deal with them.","ref":"Membrane.RawAudio.SampleFormat.html"},{"type":"function","title":"Membrane.RawAudio.SampleFormat.deserialize/1","doc":"Converts positive integer containing serialized format to atom.\n\nexpects serialized format\n\nreturns format atom (See `t:t/0`)","ref":"Membrane.RawAudio.SampleFormat.html#deserialize/1"},{"type":"function","title":"Membrane.RawAudio.SampleFormat.from_tuple/1","doc":"Converts 3-tuple format to an equivalent atom form","ref":"Membrane.RawAudio.SampleFormat.html#from_tuple/1"},{"type":"function","title":"Membrane.RawAudio.SampleFormat.serialize/1","doc":"converts audio format to 32-bit unsigned integer consisting of (from oldest bit):\n* first bit for type (int/float)\n* then bit for encoding (unsigned/signed)\n* then bit for endianity (little/big)\n* then sequence of zeroes\n* last 8 bits for size (in bits)\n\nexpects atom format\n\nreturns format encoded as integer","ref":"Membrane.RawAudio.SampleFormat.html#serialize/1"},{"type":"function","title":"Membrane.RawAudio.SampleFormat.to_tuple/1","doc":"Converts format atom to an equivalent 3-tuple form","ref":"Membrane.RawAudio.SampleFormat.html#to_tuple/1"},{"type":"function","title":"Membrane.RawAudio.SampleFormat.values/0","doc":"","ref":"Membrane.RawAudio.SampleFormat.html#values/0"},{"type":"type","title":"Membrane.RawAudio.SampleFormat.endianness_t/0","doc":"","ref":"Membrane.RawAudio.SampleFormat.html#t:endianness_t/0"},{"type":"type","title":"Membrane.RawAudio.SampleFormat.sample_size_t/0","doc":"","ref":"Membrane.RawAudio.SampleFormat.html#t:sample_size_t/0"},{"type":"type","title":"Membrane.RawAudio.SampleFormat.sample_type_t/0","doc":"","ref":"Membrane.RawAudio.SampleFormat.html#t:sample_type_t/0"},{"type":"type","title":"Membrane.RawAudio.SampleFormat.t/0","doc":"","ref":"Membrane.RawAudio.SampleFormat.html#t:t/0"},{"type":"extras","title":"Membrane Multimedia Framework: Raw audio format definition","doc":"# Membrane Multimedia Framework: Raw audio format definition\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_raw_audio_format.svg)](https://hex.pm/packages/membrane_raw_audio_format)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_raw_audio_format)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_raw_audio_format/tree/master.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_raw_audio_format/tree/master)\n\n\nThis package provides raw audio format definition for the [Membrane Multimedia Framework](https://membraneframework.org).\n\nBeyond general data structures it contains some useful helper functions for\nmanipulating raw audio samples.","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane Multimedia Framework: Raw audio format definition","doc":"Unless you're developing an Membrane Element it's unlikely that you need to\nuse this package directly in your app, as normally it is going to be fetched as\na dependency of any element that operates on raw audio.\n\nHowever, if you are developing an Element or need to add it due to any other\nreason, just add the following line to your `deps` in the `mix.exs` and run\n`mix deps.get`.\n\n```elixir\n\t{:membrane_raw_audio_format, \"~> 0.12.0\"}\n```","ref":"readme.html#installation"},{"type":"extras","title":"Copyright and License - Membrane Multimedia Framework: Raw audio format definition","doc":"Copyright 2018, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_raw_audio_format)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_raw_audio_format)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown"}